/* begin_generated_IBM_copyright_prolog                            */
/* 
 * Licensed Materials - Property of IBM 
 * 
 * 5724-N72 5655-R41 
 * 
 * Copyright IBM Corp. 2006, 2007 All Rights Reserved 
 * 
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */
/* end_generated_IBM_copyright_prolog                            */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WSRRSample.wsrrCoreAPI;

namespace WSRRSample {
    public partial class CreateGOForm : Form {
        WSRRCoreSDOService coreService;

        // Constructor
        public CreateGOForm() {
            InitializeComponent();            
        }

        // get the coreService object from the CommsHandler module
        private void CreateGOForm_Load(object sender, EventArgs e) {
            coreService = Program.comms.getCoreService();

            groupBox3_Resize(sender, e);
        }

        // Called when ther user clicks the "Create" button
        private void createButton_Click(object sender, EventArgs e) {
            this.Cursor = Cursors.WaitCursor;

            GenericObject go = new GenericObject();

            // Assign temporary bsrURI
            go.bsrURI = "_1";

            // Assign modeled properties
            go.name = GONameTextBox.Text;
            go.@namespace = GONamespaceTextBox.Text;
            go.version = GOVersionTextBox.Text;
            go.description = GODescriptionTextBox.Text;

            // Just copy across the current udps from the form           
            UserDefinedProperty[] udps = GUI_Utilities.generateUDP(userPropertiesDataGridView);
            
            go.userDefinedProperties = udps;
            create createRequest = new create();
            createRequest.datagraph = new DataGraphType();
            createRequest.datagraph.WSRR = new WSRR();
            createRequest.datagraph.WSRR.artefacts = new BaseObject[1];
            createRequest.datagraph.WSRR.artefacts[0] = go;

            // Identify the root object of the datagraph as the GO we just created
            createRequest.datagraph.WSRR.root = "_1";

            try {
                createResponse createResponse = coreService.create(createRequest);
            } catch (Exception ex) {
                Program.comms.HandleException("Could not create GenericObject: ", ex);
                return;
            } finally {
                this.Cursor = Cursors.Default;
            }

            MessageBox.Show("GenericObject created successfully");
            this.Close();
        }

        // Close the form
        private void cancelButton_Click(object sender, EventArgs e) {
            this.Close();
        }

        // Ensure that the modeled properties fields resize with the form
        private void groupBox3_Resize(object sender, EventArgs e)
        {            
            GONameTextBox.Width = (groupBox3.Width - GONameTextBox.Left - 10) / 2;
            GOVersionTextBox.Width = (groupBox3.Width - GOVersionTextBox.Left - 10) / 2;
            GONamespaceTextBox.Width = (groupBox3.Width - GONamespaceTextBox.Left - 10) / 2;
        }

        // Ensure the user properties DataGridView columns resize with the form
        private void userPropertiesDataGridView_Resize(object sender, EventArgs e)
        {
            userPropertiesDataGridView.Columns[1].Width = userPropertiesDataGridView.Width - userPropertiesDataGridView.Columns[0].Width;
        }
    }
}