/* begin_generated_IBM_copyright_prolog                            */
/* 
 * Licensed Materials - Property of IBM 
 * 
 * 5724-N72 5655-R41 
 * 
 * Copyright IBM Corp. 2006, 2007 All Rights Reserved 
 * 
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */
/* end_generated_IBM_copyright_prolog                            */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WSRRSample
{
    public partial class PreferencesForm : Form
    {
        // Constructor
        //
        // Set all the text boxes to the values stored in this applications Properties.Settings object/
        // Call securityCheckBox_CheckedChanged to enable or disable security text boxes
        public PreferencesForm()
        {
            InitializeComponent();
            endpointAddressTextBox.Text = Properties.Settings.Default.Server;
            securityCheckBox.Checked = Properties.Settings.Default.SecurityEnabled;
            portTextBox.Text = Properties.Settings.Default.Port;
            securePortTextBox.Text = Properties.Settings.Default.SecurePort;
            endpointAddressTextBox.Text = Properties.Settings.Default.Server;
            userIDTextBox.Text = Properties.Settings.Default.UserID;
            passwordTextBox.Text = Program.comms.getDecryptedPassword();
            securityCheckBox_CheckedChanged(null, null);
        }

        // Called when the OK button is clicked.
        private void OKButton_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            if (securityCheckBox.Checked)
            {
                // If security is enabled then construct the secure URLs
                Properties.Settings.Default.WSRRSample_wsrrCoreAPI_WSRRCoreSDOService = "https://" + endpointAddressTextBox.Text.Trim() + ":" + securePortTextBox.Text.Trim() + "/WSRRCoreSDO/services/WSRRCoreSDOPort"; ;
                Properties.Settings.Default.WSRRSample_WSRR_Ontology_Service_WSRROntologyWSService = "https://" + endpointAddressTextBox.Text.Trim() + ":" + securePortTextBox.Text.Trim() + "/WSRROntologyWS/services/WSRR_Ontology_Port";
                Properties.Settings.Default.WSRRSample_WSRR_Governance_Service_WSRRGovernanceWSService = "https://" + endpointAddressTextBox.Text.Trim() + ":" + securePortTextBox.Text.Trim() + "/WSRRGovernanceWSRouter/services/WSRR_Governance_Port";
            }
            else
            {
                // If security is disabled then construct the insecure URLs
                Properties.Settings.Default.WSRRSample_wsrrCoreAPI_WSRRCoreSDOService = "http://" + endpointAddressTextBox.Text.Trim() + ":" + portTextBox.Text.Trim() + "/WSRRCoreSDO/services/WSRRCoreSDOPort"; ;
                Properties.Settings.Default.WSRRSample_WSRR_Ontology_Service_WSRROntologyWSService = "http://" + endpointAddressTextBox.Text.Trim() + ":" + portTextBox.Text.Trim() + "/WSRROntologyWS/services/WSRR_Ontology_Port";
                Properties.Settings.Default.WSRRSample_WSRR_Governance_Service_WSRRGovernanceWSService = "http://" + endpointAddressTextBox.Text.Trim() + ":" + portTextBox.Text.Trim() + "/WSRRGovernanceWSRouter/services/WSRR_Governance_Port";
            }

            // Save all other settings in the Properties.Settings object
            Properties.Settings.Default.SecurityEnabled = securityCheckBox.Checked;
            Properties.Settings.Default.Port = portTextBox.Text;
            Properties.Settings.Default.SecurePort = securePortTextBox.Text;
            Properties.Settings.Default.Server = endpointAddressTextBox.Text;
            Properties.Settings.Default.UserID = userIDTextBox.Text;

            // encrypt the password so that it cannot easily be recovered by other programs
            Properties.Settings.Default.Password = Program.comms.encryptPassword(passwordTextBox.Text);

            // Persist the properties
            Properties.Settings.Default.Save();

            // As server settings may have changed we need to recreate the 3 service objects 
            Program.comms.updateReferences();

            this.Cursor = Cursors.Default;
            this.DialogResult = DialogResult.OK;
            this.Close();            
        }

        // Close the form.
        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        // Called when the user clicks the "Security enabled" checkbox. We then
        // enable/disable the correct fields to allow them to enter a userID, password 
        // and secure port
        private void securityCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (securityCheckBox.Checked)
            {
                userIDTextBox.Enabled = true;
                passwordTextBox.Enabled = true;
                securePortTextBox.Enabled = true;
                portTextBox.Enabled = false;
            }
            else
            {
                userIDTextBox.Enabled = false;
                passwordTextBox.Enabled = false;
                securePortTextBox.Enabled = false;
                portTextBox.Enabled = true;
            }

        }
    }
}